package com.usky.dxtop.service.impl;


import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.usky.dxtop.common.core.page.CommonPage;
import com.usky.dxtop.common.utils.StringUtils;
import com.usky.dxtop.mapper.DishMapper;
import com.usky.dxtop.model.Dish;
import com.usky.dxtop.service.DishService;
import com.usky.dxtop.service.vo.DishRequest;
import org.springframework.stereotype.Service;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author yq
 * @since 2021-09-09
 */
@Service
public class DishServiceImpl extends ServiceImpl<DishMapper, Dish> implements DishService {

    @Override
    public CommonPage<Dish> page(DishRequest dishRequest) {
        //TODO 后面需要改成和user表的join操作
        IPage<Dish> page = new Page<>(dishRequest.getCurrent(), dishRequest.getSize());
        LambdaQueryWrapper<Dish> queryWrapper = Wrappers.lambdaQuery();
        queryWrapper
                .like(StringUtils.isNotBlank(dishRequest.getCart()),Dish::getCard,dishRequest.getCart())
                .between(null != dishRequest.getStartTime() && null != dishRequest.getEndTime(),
                        Dish::getCreateTime,dishRequest.getStartTime(),dishRequest.getEndTime())
                .orderByDesc(Dish::getCreateTime);
        page = this.page(page, queryWrapper);
        return new CommonPage<>(page.getRecords(),page.getTotal(),page.getCurrent(),page.getSize());
    }

    @Override
    public Dish one(Long seq) {
        return this.getById(seq);
    }


}
