package com.usky.dxtop.service.listener;

import com.alibaba.fastjson.JSONObject;
import com.usky.dxtop.model.Charge;
import com.usky.dxtop.service.ChargeService;
import com.usky.dxtop.service.config.rabbitmq.ChargeTransConfig;
import lombok.extern.slf4j.Slf4j;
import org.springframework.amqp.core.Message;
import org.springframework.amqp.rabbit.annotation.RabbitListener;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.nio.charset.StandardCharsets;

/**
 * @author yq
 * @date 2021/9/9 11:05
 */
@Slf4j
@Component
public class ChargeTransMqListener {

    @Autowired
    private ChargeService chargeService;

    @RabbitListener(queues = ChargeTransConfig.NAME, containerFactory = ChargeTransConfig.LISTENER)
    public void dealDeclareMessage(Message message) {
        try {
            //消息类型
            String routingKey = message.getMessageProperties().getReceivedRoutingKey();
            log.info(routingKey);
            String s = new String(message.getBody(), StandardCharsets.UTF_8);
            log.info("charge_trans_produce:接受到的消息"+s);
            chargeService.saveOrUpdate(JSONObject.parseObject(s, Charge.class));
        } catch (Exception e) {
            log.info("charge_trans_produce"+"异常信息：" + e.getMessage());
        } finally {

        }
    }
}
